;***********************************************************
; Filename :	lab0101.asm
; Descripton :	Demonstrate Port A and E basic operation
; MCU :		PIC16F877(A)
; Copyright : 	2002-2003 Innovative Experiment
;************************************************************ 
	LIST	P=16F877,W=-302
	__CONFIG	0x3D32	; HS MODE,WDT OFF

PORTA	EQU	0x05	 ;Bank0
PORTE	EQU	0x09

TRISA	EQU	0x85	; Bank1
TRISE	EQU	0x89
ADCON1	EQU	0x9F

X	EQU	0x70	; RAM
Y	EQU	0x71
Z	EQU	0x72
ROUND	EQU	0x73
;************************************************************
	ORG	0x0000
	
	BANKSEL	ADCON1	; Select ADCON1 <bank1>
	MOVLW	B'00000111' ; PORTA,PORTE = digital port
;	MOVLW	B'00000000' ; PORTA,PORTE = analog port
	MOVWF	ADCON1	
	MOVLW	B'00110000' ; RA3:RA0 
	MOVWF	TRISA
	MOVLW	B'00000000'	; PORTE = output
	MOVWF	TRISE		

	BANKSEL	PORTA	; Select PORTA <bank0>
START	CLRF	PORTA	; Clear PORTA
	CLRF	PORTE	; Clear PORTE
	
	MOVLW	.3
	MOVWF	ROUND
	BSF	PORTA,3
	CALL	DELAY
LOOP1	RRF	PORTA,1
	CALL	DELAY
	DECFSZ	ROUND,1	
	GOTO	LOOP1	
	CLRF	PORTA
	
	MOVLW	.2
	MOVWF	ROUND
	BSF	PORTE,2
	CALL	DELAY
LOOP2	RRF	PORTE,1 
	CALL	DELAY
	DECFSZ	ROUND,1
	GOTO	LOOP2
	GOTO	START	
		
DELAY	CLRF	X	; Delay ~500 ms
	CLRF	Y
	MOVLW	.13
	MOVWF	Z
	DECFSZ	X,1
	GOTO	$-1
	DECFSZ	Y,1
	GOTO	$-3
	DECFSZ	Z,1
	GOTO	$-5
	RETURN
	
	END
