;***********************************************************
; Filename :	lab0301.asm
; Descripton :	Demonstrate Port B interrupt on change 
; MCU :		PIC16F877(A)
; Copyright : 	2002-2003 Innovative Experiment
;************************************************************
	LIST	P=16F877,W=-302
	INCLUDE	P16F877.INC
BUFFER	EQU	0x70
	__CONFIG	0x3D32
	
	ORG	0x0000	; Reset vector
	CLRF	PORTB	; Clear PORTB latch
	GOTO	MAIN
	
	ORG	0x0004	; Interrupt vector
ISR	BCF	INTCON,RBIF	; Clear interrupt flag
	MOVFW	PORTB	; Read switch
	MOVWF	BUFFER
	COMF	BUFFER,1
	SWAPF	BUFFER,0
	MOVWF	PORTB	; Show LED
CHECK_SW	MOVFW	PORTB
	ANDLW	B'11110000'	; Mask low nibble
	SUBLW	B'11110000'
	SKPZ		; Skip if all switch release
	GOTO	CHECK_SW	; Check again
	CLRF	PORTB	; Clear PORTB latch	
	RETFIE

MAIN	NOP
	BANKSEL	TRISB	; Bank 1
	MOVLW	B'11110000'	; RB3:RB0 = output
	MOVWF	TRISB	
	BANKSEL	PORTB	; Bank 0
	BSF	INTCON,GIE 	; Enable all interrupt
ENABLE	BSF	INTCON,RBIE	; Enable port B change interrupt
	SLEEP		; Enter power-down mode
	NOP
	GOTO	ENABLE

	END  
