;***********************************************************
; Filename :	lab0401.asm
; Descripton :	Demonstrate EEPROM writing
; MCU :		PIC16F877(A)
; Copyright : 	2002-2003 Innovative Experiment
;************************************************************
	LIST	P=16F877,W=-302
	__CONFIG	0x3D32

PORTB	EQU	0x06	; Bank0
TRISB	EQU	0x86	; Bank1

EEDATA	EQU	0x10C	; Bank2
EEADR	EQU	0x10D	

EECON1	EQU	0x18C	; Bank3
EECON2	EQU	0x18D

EEPGD	EQU	7
WRERR	EQU	3
WREN	EQU	2
WR	EQU	1

START	ORG	0x000

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

         CONSTANT   EE_ADDRESS  = 0x08		
         CONSTANT   EE_DATA	= 0xAB

	BANKSEL	TRISB	; Selelct TRISB <bank1>
	BCF	TRISB,0 	; RB0 = output
	BANKSEL	PORTB	; Select PORTB <bank0>
	BCF	PORTB,0	; Turn-off LED
	CALL	WRITE
	GOTO	$-1
	
WRITE
	BANKSEL	EEADR	; Select EEADR < BANK2>

	MOVLW	EE_ADDRESS	; Assign address
	MOVWF	EEADR
	MOVLW	EE_DATA	; Assign data
	MOVWF	EEDATA	
	
	BANKSEL	EECON1	; Select EECON1 <bank3>
	BCF	EECON1,EEPGD	; Data EEPROM section
	BSF	EECON1,WREN	; Write enable

	MOVLW	0x55	; Write sequence
	MOVWF	EECON2	
	MOVLW	0xAA
	MOVWF	EECON2	
	
	BSF	EECON1,WR	; Writing start
	BTFSC	EECON1,WR	; Skip if completed 
	GOTO	$-1	; WAIT 
	BCF	EECON1,WREN	; Disable writing
	
	BANKSEL	PORTB	; Select PORTB <bank0>
	BSF	PORTB,0	; Turn-on LED
	RETURN
	
	END
