;***********************************************************
; Filename :	lab0501.asm
; Descripton :	Demonstrate EEPROM reading
; MCU :		PIC16F877(A)
; Copyright : 	2002-2003 Innovative Experiment
;************************************************************
	LIST	P=16F877,W=-302
	__CONFIG	0x3D32


PORTB	EQU	0x06	; Bank0
TRISB	EQU	0x86	; Bank1
EEDATA	EQU	0x10C	; Bank2
EEADR	EQU	0x10D	
EECON1	EQU	0x18C	; Bank3

EEPGD	EQU	7
RD	EQU	0

START	ORG	0x000

;************************************************************

	BANKSEL	TRISB	; Select TRISB <bank1>
	CLRF	TRISB	; Port B = output
	BANKSEL	PORTB	; Select PORTB <bank0>
	CLRF	PORTB	
	
READ
	BANKSEL	EEADR	; Select EEADR <bank2>	
	CLRF	EEADR	; Address = 0x00
LOOP			
	BANKSEL	EECON1	; Select EECON1 <bank3>
	BCF	EECON1,EEPGD	; Data EEPROM section	
	BSF	EECON1,RD	; Read enable

	BANKSEL	EEDATA	; Select EEDATA <bank2>
	MOVFW	EEDATA	; Read data
	MOVWF	PORTB	; Show data
	CALL	DELAY
	INCF	EEADR,1
	BTFSS	EEADR,3
	GOTO	LOOP
	GOTO	$	; Stop

DELAY	CLRF	0x70
	CLRF	0x71
	MOVLW	.15
	MOVWF	0x72
	DECFSZ	0x70,1
	GOTO	$-1
	DECFSZ	0x71,1
	GOTO	$-3
	DECFSZ	0x72,1
	GOTO	$-5
	RETURN
	
	ORG	0x2100
	DE	1,2,3,4,5,6,7,8 ; Address 0x00-0x07

	END
