;***********************************************************
; Filename :	lab0601.asm
; Descripton :	Demonstrate flash memory writing
; MCU :		PIC16F877
; Copyright : 	2002-2003 Innovative Experiment
;************************************************************
	LIST	P=16F877,W=-302
	__CONFIG	0x3F32	; Write enable ,code protect off

PORTB	EQU	0x06	; Bank0
TRISB	EQU	0x86	; Bank1

EEDATA	EQU	0x10C	; Bank2
EEDATH	EQU	0x10E
EEADR	EQU	0x10D
EEADRH	EQU	0x10F

EECON1	EQU	0x18C	; Bank3
EECON2	EQU	0x18D

EEPGD	EQU	7
WRERR	EQU	3
WREN	EQU	2
WR	EQU	1

START	ORG	0x000

;************************************************************

         CONSTANT   EE_ADDR_HIGH  = 0x1F	; Program memory address
         CONSTANT   EE_ADDR_LOW   = 0xF8		         

         CONSTANT   EE_DATA_HIGH  = 0x22	; Program memory data
         CONSTANT   EE_DATA_LOW   = 0x22

	BANKSEL	TRISB	; Select TRISB <bank1>
	BCF	TRISB,0 	; RB0 = output
	BANKSEL	PORTB	; Select PORTB <bank0>
	BCF	PORTB,0	; Turn-off LED
	CALL	WRITE
	GOTO	$-1
	
WRITE
	BANKSEL	EEADR	; Select EEADR <bank2>
	MOVLW	EE_ADDR_HIGH	; High address of EEPROM
	MOVWF	EEADRH
	MOVLW	EE_ADDR_LOW	; Low address of EEPROM 
	MOVWF	EEADR
	
	MOVLW	EE_DATA_HIGH	; Data high byte
	MOVWF	EEDATH	
	MOVLW	EE_DATA_LOW     ; Data low byte
	MOVWF	EEDATA	
	
	BANKSEL	EECON1	; Select EECON1 <bank3>
	BSF	EECON1,EEPGD	; Program EEPROM section
	BSF	EECON1,WREN	; Enable writing

	MOVLW	0x55	; Writing sequence
	MOVWF	EECON2	
	MOVLW	0xAA
	MOVWF	EECON2	
	
	BSF	EECON1,WR	; Writing start here
	NOP		; Delay 2 cycles
	NOP
	BTFSC	EECON1,WR	; Skip if completed
	GOTO	$-1	; Wait 
	BCF	EECON1,WREN	; Disable writing 
	
	BANKSEL	PORTB	; Select PORTB <bank0>
	BSF	PORTB,0	; Turn-on LED
	RETURN
	
	END
