;***********************************************************
; Filename :	lab0701.asm
; Descripton :	Demonstrate flash program memory reading
; MCU :		PIC16F877(A)
; Copyright : 	2002-2003 Innovative Experiment
;************************************************************
	LIST	P=16F877,W=-302
	__CONFIG	0x3D32


PORTB	EQU	0x06	; Bank0
PORTC	EQU	0x07
TRISB	EQU	0x86	; Bank1
TRISC	EQU	0x87
EEDATA	EQU	0x10C	; Bank2
EEDATH	EQU	0x10E
EEADR	EQU	0x10D	
EEADRH	EQU	0x10F
EECON1	EQU	0x18C	; Bank3

EEPGD	EQU	7
RD	EQU	0

START	ORG	0x000

;************************************************************

	BANKSEL	TRISB	; Select TRISB <bank1>
	CLRF	TRISB	; PORTB = output
	CLRF	TRISC	; PORTC = output
	BANKSEL	PORTB	; Select PORTB <bank0>
	CLRF	PORTB
	CLRF	PORTC
READ
	BANKSEL	EEADR	; Select EEADR < Bank2>	
	CLRF	EEADRH	; Address = 0x0050
	MOVLW	0x50
	MOVWF	EEADR	
LOOP			
	BANKSEL	EECON1	; Select EECON1 <bank3>
	BSF	EECON1,EEPGD	; Program memory section	
	BSF	EECON1,RD	; Read enable
	NOP		; Delay 2 cycles
	NOP

	BANKSEL	EEDATA	; Select EEDATA <bank2>
	MOVFW	EEDATA
	MOVWF	PORTB
	MOVFW	EEDATH	; Read data
	BANKSEL	PORTC	; Select PORTC <bank0>
	MOVWF	PORTC	; Show data
	GOTO	$	; Stop
	
	ORG	0x0050
	FILL	0x1234,1

	END
