;***********************************************************
; Filename :	lab0801.asm
; Descripton :	Demonstrate flash memory writing for PIC16F877A
; MCU :		PIC16F877A
; Copyright : 	2002-2003 Innovative Experiment
;************************************************************
	LIST	P=16F877A,W=-302
	INCLUDE	P16F877A.INC
	__CONFIG	0x3F72	; HS_OSC,WDT_OFF,FLASH_WRITE
	
	ORG	0x0000
	
	
	BANKSEL	EEADRH	; Bank 2
	MOVLW	0x00
	MOVWF	EEADRH	; Address high_1
	MOVLW	0x40
	MOVWF	EEADR	; Adress low_1

	MOVLW	0x01
	MOVWF	EEDATH	; Data high_1
	MOVLW	0xAA
	MOVWF	EEDATA	; Data low_1
	CALL	WR_FLASH

	MOVLW	0x02
	MOVWF	EEDATH	; Data high_2
	MOVLW	0xBB
	MOVWF	EEDATA	; Data low_2
	CALL	WR_FLASH

	MOVLW	0x03
	MOVWF	EEDATH	; Data high_3
	MOVLW	0xCC
	MOVWF	EEDATA	; Data low_3
 	CALL	WR_FLASH

	MOVLW	0x04
	MOVWF	EEDATH	; Data high_4
	MOVLW	0xDD
	MOVWF	EEDATA	; Data low_4
	CALL	WR_FLASH

	GOTO	$	; End of job

WR_FLASH			; Writ each word subroutine
	BANKSEL	EECON1	; Bank 3
	BSF	EECON1,EEPGD	; Point to program memory
	BSF	EECON1,WREN	; Write enable
	
	MOVLW	0x55	; Required write sequence
	MOVWF	EECON2
	MOVLW	0xAA
	MOVWF	EECON2
	BSF	EECON1,WR	; Writing start here
	NOP		; Wait 2 cycles
	NOP	

	BCF	EECON1,WREN	; Disable writing 
	BANKSEL	EEDATA	; Bank 2
	INCF	EEADR,1	; Increases address (3 addresses for data 1-3)
	RETURN
		
	END
