;***********************************************************
; Filename :	lab1201.asm
; Descripton :	Demonstrate receiving data from PC serial port via USART module in PIC16F87x 
; MCU :		PIC16F877(A)
; Copyright : 	2002-2003 Innovative Experiment
;************************************************************
LIST      P=16F877 ,W = -302      
	#include <p16f877.inc>   
CONFIG1 = _CP_OFF&_WDT_OFF&_BODEN_ON&_PWRTE_ON
CONFIG2 = _HS_OSC&_WRT_ENABLE_ON&_LVP_OFF
	__CONFIG CONFIG1 & CONFIG2
		
		CBLOCK	0x20
W_TEMP
S_TEMP
DAT
FLAG_
		ENDC

#DEFINE NEWDATA  FLAG_,0

			ORG     0x000  		; Processor reset vector
			CLRF    PCLATH  		; Ensure page bits are cleared
		  	GOTO    Init     		; Go to beginning of program
			ORG     0x004    		; Interrupt vector location
			GOTO	ISR

;- INTERRUPT SERVICE ROUTINE ---
ISR		MOVWF   W_TEMP          	; Save off current W register contents
			MOVF	STATUS,w     ; Move status register into W register
			BCF     STATUS,RP0      ; Ensure file register bank set to 0
			MOVWF	S_TEMP       	; Save off contents of STATUS register

			MOVF	RCREG,W
			MOVWF	DAT
			BSF	NEWDATA
			MOVF    S_TEMP,w     		; Retrieve copy of STATUS register
			MOVWF	STATUS         		; Restore pre-isr STATUS register contents
			SWAPF   W_TEMP,f
			SWAPF   W_TEMP,w      	 	; Restore pre-isr W register contents
			RETFIE
      
Init 		BSF	STATUS,RP0		; Bank 1
			MOVLW	.129			; For 9600 bps 0.16% Error
			MOVWF	SPBRG
			BCF	TXSTA,SYNC		; Asynchonous Mode 
			BSF	TXSTA,BRGH		; Set Baudrate Speed High
			BSF	TXSTA,TXEN		; Enable Transmit Data
			BSF	PIE1,RCIE		; Enable Reiciever Interrupt
			MOVLW	b'00000000'
			MOVWF	PORTB
			BCF	STATUS,RP0
			BSF	INTCON,PEIE	; Enable Periperal Interrupt
			BSF	INTCON,GIE		; Enable Interrupt
			BSF	RCSTA,SPEN		; Enable Serial Port
			BSF	RCSTA,CREN		; Enable Recieve Data
			MOVF	RCREG,W		; Flush Data
			MOVF	RCREG,W
			MOVF	RCREG,W

;--- START Program Here -----;
Wait_ST	BCF	NEWDATA
			btfss	NEWDATA
			GOTO	$-1
			MOVF	DAT,w
			MOVWF	PORTB
			GOTO	Wait_ST
	
		END
