;***********************************************************
; Filename :	lab1202.asm
; Descripton :	Demonstrate transmission data from MCU to PC via PC serial port 
; MCU :		PIC16F877(A)
; Copyright : 	2002-2003 Innovative Experiment
;************************************************************

LIST      P=16F877   ,W = -302   
	#include <p16f877.inc>   
CONFIG1 = _CP_OFF&_WDT_OFF&_BODEN_ON&_PWRTE_ON
CONFIG2 = _HS_OSC&_WRT_ENABLE_ON&_LVP_OFF

		__CONFIG CONFIG1 & CONFIG2
		
		CBLOCK	0x20
W_TEMP
S_TEMP
DAT
Flag_
SEND_DAT
CNT1
CNT2
		ENDC
#DEFINE NEWDATA  FLAG_,0

			ORG     0x000             ; Processor reset vector
			CLRF    PCLATH            ; Ensure page bits are cleared
  		GOTO    INIT              ; Go to beginning of program

INIT 	BSF	STATUS,RP0		; Bank 1
			MOVLW	.129			; For 9600 bps 0.16% Error
			MOVWF	SPBRG
			BCF	TXSTA,SYNC		; Asynchonous Mode 
			BSF	TXSTA,BRGH		; Set Baudrate Speed High
			BSF	TXSTA,TXEN		; Enable Transmit Data
			MOVLW	b'11111111'
			movwf	PORTB
			BCF	STATUS,RP0
			BSF	RCSTA,SPEN		; Enable Serial Port

ZERO		MOVLW	.255
LOOP		CALL	SEND
			CALL	DELAY
			DECFSZ	SEND_DAT,f
			GOTO	LOOP
			GOTO	ZERO

SEND		BTFSS	PIR1,TXIF
			GOTO	$-1
			MOVF	SEND_DAT,W
			MOVWF	TXREG
			RETURN

DELAY 	CLRF 	CNT1			; ~ 200 mSec Delay Times	
DELAY1 	CLRF 	CNT2
DELAY2	GOTO	$+1		
			GOTO	$+1
			GOTO	$+1
			GOTO	$+1
			GOTO	$+1
			GOTO	$+1
			DECFSZ 	CNT2,f
			GOTO 	DELAY2			; Jump PC-1
			DECFSZ 	CNT1,f
			GOTO 	DELAY1
			RETURN
	
			END

