;***********************************************************
; Filename :	lab1301.asm
; Descripton :	Demonstrate capture module operation by used to counts the frequency of pulse signal   
; MCU :		PIC16F877(A)
; Copyright : 	2002-2003 Innovative Experiment
;************************************************************

	LIST	P=16F877,W=-302
	INCLUDE	P16F877.INC	; PIC16F877 include file
	__CONFIG	0x3D72	; HS-MODE 20 MHz

;*******************************************************************************

	ORG	0x000	; Goto main program
	GOTO	MAIN
	ORG	0x004	; Goto interrupt service routine
	GOTO	ISR

MAIN	CLRF	PORTB	; Clear PORTB
	CLRF	PORTD	; Clear PORTD
	BANKSEL	TRISB	; Select TRISB <bank1>
	CLRF	TRISB	; Port B as output
	CLRF	TRISD	; Port D as output
	
CAPTURE1_SETUP  BSF	PIE1,CCP1IE 	; CCP1 interrupt enable
	BANKSEL	T1CON	; Select T1CON <bank0>
	MOVLW	B'00110000' 	; Select internal clock, 1:8 prescaler and TMR1 off
	MOVWF	T1CON       	 
	CALL	START
	BSF	INTCON,PEIE	; Peripheral interrupt enable	
	GOTO	$	; Wait for interrupt

ISR	CLRF	CCP1CON	; Turn-off capture module 
	BCF	T1CON,TMR1ON 	; Turn-off Timer1	
SHOWTIME	MOVFW	CCPR1H	; High byte data on port D
	MOVWF	PORTD
	MOVFW	CCPR1L	
	MOVWF	PORTB	; Low byte data on port B
	GOTO	START


START	CLRF	TMR1H	; Clear TMR1
	CLRF	TMR1L
	BCF	PIR1,CCP1IF	; Clear CCP1 interrupt flag 
	MOVLW	B'00000101' 	; Define every rising edge for capture module
	MOVWF	CCP1CON
	BCF	PIR1,CCP1IF	; Clear CCP1 interrupt flag 
	BTFSS	PIR1,CCP1IF	; Teat flag for starting capture module
	GOTO	$-1	; Wait for the first rising edge of input signal 
	BSF	T1CON,TMR1ON	; Counting capture time 
	BCF	PIR1,CCP1IF     ; Clear CCP1 interrupt flag 
	RETFIE		; Return from interrupt and enable global interrupt 


	END
