;***********************************************************
; Filename :	lab1401.asm
; Descripton :	Demonstrate PWM module operation by generate PWM signal which duty cycle adjustable 20%-80%
; MCU :		PIC16F877(A)
; Copyright : 	2002-2003 Innovative Experiment
;************************************************************
	LIST	P=16F877,W=-302
	__CONFIG	0x3D32
	
PORTC	EQU	0x07	; Bank0
CCPR2L	EQU	0x1B
CCP2CON	EQU	0x1D
T2CON	EQU	0x12
TMR2	EQU	0x11
TRISC	EQU	0x87	; Bank1
PR2	EQU	0x92

TMR2ON	EQU	2	; Bit
CCP2X	EQU	5
CCP2Y	EQU	4
;************************************************************	ORG	0x0000		

MAIN_PROGRAM:	NOP	
	BANKSEL	TRISC	; Bank1
	BCF	TRISC,1	; RC1 = output <CCP2>
	MOVLW	.124
	MOVWF	PR2
	BANKSEL	PORTC	; Return bank0
	
	MOVLW	B'00101111'	; PWM mode,CCP2X=1,CCP2Y=0
	MOVWF	CCP2CON	
	MOVLW	B'00111110'	; Fpwm = 2.5kHz.,duty cycle = 50%	
	MOVWF	CCPR2L	
	MOVLW	B'00000010'	; Precscaler = 1:16, TMR2 off
	MOVWF	T2CON
	CLRF	TMR2	; Clear TMR2
	BSF	T2CON,TMR2ON	; TMR2 on

SELECT	BTFSS	PORTC,4	; Read switch
	GOTO	DUTY20
	BTFSS	PORTC,5
	GOTO	DUTY40
	BTFSS	PORTC,6
	GOTO	DUTY60
	BTFSS	PORTC,7
	GOTO	DUTY80
	GOTO	SELECT

DUTY20	MOVLW	B'00011001'	; Fpwm = 2.5kHz., duty cycle = 20%
	GOTO	DUTY_ADJ
DUTY40	MOVLW	B'00110010'	; Fpwm = 2.5kHz., duty cycle = 40%
	GOTO	DUTY_ADJ
DUTY60	MOVLW	B'01001011'     ; Fpwm = 2.5kHz., duty cycle = 60%
	GOTO	DUTY_ADJ
DUTY80	MOVLW	B'01100100'	; Fpwm = 2.5kHz., duty cycle = 80%
	GOTO	DUTY_ADJ

DUTY_ADJ	MOVWF	CCPR2L
	BCF	CCP2CON,CCP2X
	BCF	CCP2CON,CCP2Y
	GOTO	SELECT	

	END
