;***********************************************************
; Filename :	lab1501.asm
; Descripton :	Demonstrate basic operation of ADC module in PIC16F87x 
; MCU :		PIC16F877(A)
; Copyright : 	2002-2003 Innovative Experiment
;************************************************************

	LIST	P=16F877,W=-302

;****************** REGISTER EQUATE *********************
PORTB	EQU	0x06	; Bank0
PORTC	EQU	0x07
ADCON0	EQU	0x1F
ADRESH	EQU	0x1E

TRISA	EQU	0x85	; Bank1
TRISB	EQU	0x86
TRISC	EQU	0x87
TRISE	EQU	0x89
ADCON1	EQU	0x9F
ADRESL	EQU	0x9E

ADFM	EQU	7
GO_DONE	EQU	2
ADON	EQU	0

ACQ_VAR	EQU	0x70	; Common RAM

	__CONFIG	0x3D32	; HS 20MHz, WDT OFF
	ORG	0x0000

	BANKSEL	TRISA	; Select TRISA <bank1>
	MOVLW	B'11111111'  
	MOVWF	TRISA	; Port A   = input
	MOVLW	B'00000111'
	MOVLW	TRISE	; Port E   = input
	CLRF	TRISC	; Port C   = output
	CLRF	TRISB	; Port B   = output

SET_ADCON1	MOVLW	B'10001000' ; Right justified,
	MOVWF	ADCON1	; 6 channels, 2 references
;LEFT_JUSTF	BCF	ADCON1,ADFM	; Left justified

	BANKSEL	PORTB	; Select PORTB <bank0>
	CLRF	PORTC	; Turn-off LED : upper 8-bit
	CLRF	PORTB	; Turn-off LED : lower 8-bit
	 
SET_ADCON0	MOVLW	B'10000000'   ; ADC clock = Fosc/32 @20 MHz.,  
	MOVWF	ADCON0	; Channel0 (RA0)
DO_AGAIN	BSF	ADCON0,ADON	; Turn-on ADC module
	CALL	ACQ_TIME 	; Delay for acquisition time
	BSF	ADCON0,GO_DONE ; Start conversion 

CON_WAIT	BTFSC	ADCON0,GO_DONE ; Wait for conversion complete    
	GOTO	CON_WAIT	
	BCF	ADCON0,ADON	; Disable ADC module

	MOVFW	ADRESH	; Read ADC result
	MOVWF	PORTC	; Show upper 8-bit on port C 

	BANKSEL	ADRESL	; Select ADRESL <bank1>
	MOVFW	ADRESL	 
	BANKSEL	PORTB	; Select PORTB  <bank0>
	MOVWF	PORTB	; Show lower 8-bit on port B
	
	GOTO	DO_AGAIN  	; ** Next conversion **      

ACQ_TIME	MOVLW	.34	; Delay 20 microcsecond 
	MOVWF	ACQ_VAR
	DECFSZ	ACQ_VAR,1
	GOTO	$-1
	GOTO	$+1
	RETURN	

	END 
