;***********************************************************
; Filename :	lab2001.asm
; Descripton :	Demonstrate analog comparator operation in PIC16F87xA 
; MCU :		PIC16F876A
; Copyright : 	2002-2003 Innovative Experiment
;************************************************************
	LIST	P=16F876A,W=-302

PORTA	EQU	0x05	; Bank 0	

TRISA	EQU	0x85	; Bank 1
CMCON	EQU	0x9C	;
ADCON1	EQU	0x9F	;

VAR_X	EQU	0x20	; Bank 0

	__CONFIG	0x3932
	ORG	0x0000
	
	BCF	PORTA,5	; Clear RA5 latch after reset
	BANKSEL	ADCON1	; Select bank 1
	MOVLW	B'00000010'	; RA5 = digital port
	MOVWF	ADCON1	
	BCF	TRISA,5	; RA5 = output
NON_INVERT	MOVLW	B'00000011'	; C2OUT = non-invert logic ,mode 3
;INVERT	MOVLW	B'00100011'	; C2OUT = invert logic, mode 3
	MOVWF	CMCON	
	BANKSEL	PORTA	; Returm to bank 0
	
OPERATE	CALL	DELAY10US	; Delay ~10 microsecond
	GOTO	OPERATE	
	
DELAY10US	MOVLW	.17	; This value for 20MHz xtal
	MOVWF	VAR_X
	DECFSZ	VAR_X,1	
	GOTO	$-1
	RETURN
	
	END		
