;***********************************************************
; Filename :	lab2101.asm
; Descripton :	Demonstrate analog comparator operation with internal voltage refernce in PIC16F87xA 
; MCU :		PIC16F876A
; Copyright : 	2002-2003 Innovative Experiment
;************************************************************
	LIST	P=16F876A,W=-302

PORTB	EQU	0x06	; Bank 0	

TRISB	EQU	0x86	; Bank 1
CVRCON	EQU	0x9D	;
CVREN	EQU	0x07	; BIT	
CVROE	EQU	0x06	;
CVRR	EQU	0x05	;
VAR_X	EQU	0x20	; Bank 0

	__CONFIG	0x3932	
	ORG	0x0000
	
	CLRF	PORTB	; Clear port B latch after reset	
	BANKSEL	TRISB	; Select bank 1
	MOVLW	B'00001111'	; RB7:RB4 = output,RB3:RB0 = input
	MOVWF	TRISB
	BSF	CVRCON,CVRR	; Select low range
	BANKSEL	PORTB	; Return to bank 0
	CALL	VREF_1	
	
SW_RANGE	BTFSS	PORTB,0	; Range 1
	CALL	VREF_1
	BTFSS	PORTB,1	; Range 2
	CALL	VREF_2
	BTFSS	PORTB,2	; Range 3
	CALL	VREF_3
	BTFSS	PORTB,3	; Range 4
	CALL	VREF_4
	GOTO	SW_RANGE
	
VREF_1	MOVLW	B'00010000'
	MOVWF	PORTB
	MOVLW	B'11100110'
	GOTO	VREF_ENABLE

VREF_2	MOVLW	B'00100000'
	MOVWF	PORTB
	MOVLW	B'11101010'
	GOTO	VREF_ENABLE

VREF_3	MOVLW	B'01000000'
	MOVWF	PORTB
	MOVLW	B'11101101'
	GOTO	VREF_ENABLE

VREF_4	MOVLW	B'10000000'
	MOVWF	PORTB
	MOVLW	B'11101111'
	GOTO	VREF_ENABLE

VREF_ENABLE	NOP
	BANKSEL	CVRCON	; Select CVRCON
	MOVWF	CVRCON
	BANKSEL	PORTB	; Return to bank 0	
DELAY10US	MOVLW	.17	; This value for 20MHz xtal 
	MOVWF	VAR_X
	DECFSZ	VAR_X,1	
	GOTO	$-1
	RETURN
	
	END		
