;************************************************************
; Filename :	lab2201.asm
; Description :	Demonstrate SPI module operation by ;				interface with MC14489 5-digit LED display IC
; MCU :		PIC16F877(A)
; Copyright 2002-2003 Innovative Experiment Co.,Ltd. Thailand
;************************************************************
	LIST	P=16F877,W=-302
	INCLUDE	P16F877.INC
	__CONFIG	0x3D32	; HS 20 MHz.
       CBLOCK   0x20		; Bank0
         R0,R1,R2,COUNT,H_BYTE,L_BYTE,TEMP,TEST
           ENDC
#DEFINE	SLAVE_DISABLE	BSF  PORTC,0	; MC14489's enable pin 
#DEFINE	SLAVE_ENABLE	BCF  PORTC,0	
                                     
	ORG	0x0000
	
PORT_SETUP	SLAVE_DISABLE		; Disable MC14489
	BANKSEL	TRISC	; Bank1
	MOVLW	B'11010110'	; RC5,RC3,RC0 = output
	MOVWF	TRISC	
	BSF	SSPSTAT,CKE	; CKE=1 (First edge/rising edge) 	
	BANKSEL	SSPCON	; Bank0
	MOVLW	B'00000001'	; Fosc/16,CKP=0 (Idle clock low)
	MOVWF	SSPCON
	BSF	SSPCON,SSPEN	; Enable master
		
	MOVLW	B'11000001'	; Setup configuration
	CALL 	TX
	SLAVE_DISABLE
	

	MOVLW	0xFF
	MOVWF	TEST
	
AGAIN	BTFSC	PORTC,7	; Find clock's falling edge
	GOTO	$-1
	BTFSS	PORTC,7	; Wait clock's rising edge
	GOTO	$-1
	BTFSC	PORTC,7	; Wait clock's falling edge
	GOTO	$-1
	INCF	TEST,1
	MOVFW	TEST
	MOVWF	L_BYTE
	CALL	BCD
	CALL	SEND
	GOTO	AGAIN	
	
SEND	MOVLW	B'10010000'	; DP1:DIGIT5
	CALL	TX
	MOVFW	R1
	CALL	TX	
	MOVFW	R2
	CALL	TX
	SLAVE_DISABLE
	RETURN
TX	SLAVE_ENABLE
	MOVWF	SSPBUF
	BANKSEL	SSPSTAT	; Bank1
	BTFSS	SSPSTAT,BF	; Skip if complete
	GOTO	$-1	
	BANKSEL	SSPBUF	; Bank0
	MOVFW	SSPBUF	; Clear buffer flag
	RETURN
BCD  	CLRF    	H_BYTE
	CLRC	
	MOVLW   	.16
	MOVWF   	COUNT
	CLRF    	R0
	CLRF    	R1
	CLRF    	R2
LOOP16  	RLF     	L_BYTE,1
	RLF     	H_BYTE,1
	RLF     	R2,1
	RLF     	R1,1
	RLF     	R0,1
	DECFSZ  	COUNT,1
	GOTO    	ADJDEC
	RETLW   	0x00
ADJDEC  	MOVLW   	R2	; Adjust data to decimal routine
	MOVWF   	FSR
	CALL    	ADJBCD
	MOVLW   	R1
	MOVWF   	FSR
	CALL    	ADJBCD
	MOVLW   	R0
	MOVWF   	FSR
	CALL    	ADJBCD
	GOTO    	LOOP16
ADJBCD  	MOVLW   	0x03
	ADDWF   	INDF,0
	MOVWF   	TEMP
	BTFSC   	TEMP,3          
	MOVWF   	INDF
	MOVLW   	0x30
	ADDWF   	INDF,0
	MOVWF   	TEMP
	BTFSC   	TEMP,7          
	MOVWF   	INDF            
	RETLW   	0x00

	END



