;***********************************************************
; Filename :	lab2401.asm
; Descripton :	Demonstrate using SSP module in I2C master mode for interface PCF8574A i/o expander 
; MCU :		PIC16F877 (A)
; Copyright : 	2002-2003 Innovative Experiment
;************************************************************
	LIST	P=16F877,W=-302
	INCLUDE	P16F877.INC
	__CONFIG	0x3D7A
	ORG	0x0000

INIT_I2C	NOP
	BANKSEL	TRISC	; Bank1
	BSF	TRISC,3	; RC3 = input only
	BSF	TRISC,4	; RC4 = input only
	MOVLW	.49	; SCL clock = 100kHz
	MOVWF	SSPADD	
	BSF	SSPSTAT,SMP	; Standard mode	

	BANKSEL	SSPCON	; Bank0
	MOVLW	B'00001000'	; I2C master mode
	MOVWF	SSPCON		
	BSF	SSPCON,SSPEN	; SSP enable
	
	CALL	START_I2C	
	
	MOVLW	B'01110000'	; Slave address, write slave	
	CALL	WRITE_I2C
	
LOOP	MOVLW	0xAA
	CALL	WRITE_I2C
	CALL	DELAY

	MOVLW	0x55
	CALL	WRITE_I2C
	CALL	DELAY
	GOTO	LOOP	

START_I2C	NOP
	BANKSEL	SSPCON2	; Bank1
	BSF	SSPCON2,SEN	; I2C start
	CALL	CHECK_SSPIF	; Wait for start completed
	RETURN

WRITE_I2C	NOP
	BANKSEL	SSPBUF	; Bank0
	MOVWF	SSPBUF	; Write address or data
	CALL	CHECK_SSPIF	; Wait for writing completed	
	BANKSEL	SSPCON2	; Bank1
	BTFSS	SSPCON2,ACKSTAT	; Skip if no acknowledge
	RETURN	
	CALL	STOP_I2C
	GOTO	$	; Endless loop if no acknowledge
	
CHECK_SSPIF	NOP
	BANKSEL	PIR1	; Bank0
	BTFSS	PIR1,SSPIF	; Skip if completed
	GOTO	$-1	
CLEAR_SSPIF	BCF	PIR1,SSPIF
	RETURN
STOP_I2C	NOP
	BANKSEL	SSPCON2	; Bank1
	BSF	SSPCON2,PEN	; Stop I2C, release SCL & SDA line
	CALL	CHECK_SSPIF	; Wait for stop completed
	RETURN	

DELAY	CLRF	0x70
	CLRF	0x71
	MOVLW	.6
	MOVWF	0x72
	DECFSZ	0x70,1
	GOTO	$-1
	DECFSZ	0x71,1
	GOTO	$-3
	DECFSZ	0x72,1
	GOTO	$-5
	RETURN
	END
